create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_CONTENT_ON_TRANSFERS(IN _id_transfer int, IN _field int(10),
                                                                        IN _query varchar(192), IN _filter varchar(192),
                                                                        IN _limit_size_a bigint,
                                                                        IN _limit_size_b bigint, IN _limit_a int,
                                                                        IN _limit_b int)
BEGIN

DECLARE sqlcommand text;
DECLARE sqlcommand_v text;
DECLARE sqlcommand_c text;
DECLARE sqlcommand_v_fst text;
DECLARE sqlcommand_c_snd text;
DECLARE t1_a text;
DECLARE t1_b text;

DECLARE _total_video int;
DECLARE _total_clip int;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

DROP TEMPORARY TABLE IF EXISTS trf1;
SET t1_a = "CREATE TEMPORARY TABLE IF NOT EXISTS trf1 ";
SET t1_b = "insert into trf1 ";

IF(_limit_b = -1)
THEN
	SELECT count(1) into _total_video FROM archive_transfers_videos_related WHERE id_transfer = _id_transfer;
	SELECT count(1) into _total_clip FROM archive_transfers_clips_related WHERE id_transfer = _id_transfer;
	SET _limit_b = _total_video+_total_clip;
END IF;

SET @_id_transfer = _id_transfer;
SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_limit_size_a = _limit_size_a;
SET @_limit_size_b = _limit_size_b;
SET @_state = _query;
SET @_isclip = _query;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET @_year = year(_filter);
SET @_month = month(_filter);



SET sqlcommand_v = "SELECT av.id_video,id_directory,id_storage,id_cdn,0 as is_clip,av.name,filename,seconds as duration,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,av.register_date,
							 FN_GET_ARCHIVE_VIDEO_HAS_PREVIEW(av.id_video) has_preview,FN_GET_ARCHIVE_VIDEO_THUMBNAIL(av.id_video) as thumbnail,FN_GET_ARCHIVE_VIDEO_TOTAL_CLIPS(av.id_video) as total_clips, tvr.position, at.create_xml
				FROM archive_videos av, archive_transfers_videos_related tvr, archive_transfers at
 WHERE av.id_video = tvr.id_video AND at.id_transfer = tvr.id_transfer AND av.deleted = 0 AND tvr.id_transfer = ? ";

SET sqlcommand_v_fst = CONCAT(t1_a,sqlcommand_v);
SET @sqlcommand_v_fst = sqlcommand_v_fst;

PREPARE stmt_fst FROM @sqlcommand_v_fst;
EXECUTE stmt_fst USING @_id_transfer;

SET sqlcommand_c = "SELECT ac.id_clip,id_directory,id_storage,id_cdn,1 as is_clip,ac.name,filename,seconds as duration,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,ac.register_date,
							 FN_GET_ARCHIVE_CLIP_HAS_PREVIEW(ac.id_video) has_preview,FN_GET_ARCHIVE_CLIP_THUMBNAIL(ac.id_clip) as thumbnail,FN_GET_ARCHIVE_VIDEO_TOTAL_CLIPS(ac.id_video) as total_clips, tvr.position, at.create_xml
				FROM archive_clips ac, archive_transfers_clips_related tvr, archive_transfers at
 WHERE ac.id_clip = tvr.id_clip AND at.id_transfer = tvr.id_transfer AND ac.deleted = 0 AND tvr.id_transfer = ? ";

SET sqlcommand_c_snd = CONCAT(t1_b,sqlcommand_c);

SET @sqlcommand_c_snd = sqlcommand_c_snd;

PREPARE stmt_snd FROM @sqlcommand_c_snd;
EXECUTE stmt_snd USING @_id_transfer;


SET sqlcommand = "SELECT * FROM trf1 WHERE 1=1 ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like ? ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND is_clip = ? ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = ? AND month(register_date) = ?) AND (name like ? ) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = ?) AND (name like ? ) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = ?) AND (name like ?) ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (mime_type like ?) AND (name like ?) ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (CONCAT(width,'x',height) like ?) AND (name like ?) ");
WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (size BETWEEN ? AND ?) AND (name like ?) ");
WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND is_clip = 0 AND id_video = ? ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND is_clip = 1 AND id_video = ? ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;
SET sqlcommand = CONCAT(sqlcommand, " ORDER BY position, register_date DESC LIMIT ?,?");
SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _field = 1 THEN
EXECUTE stmt USING @_name,@_limit_a,@_limit_b;
WHEN _field = 2 THEN
EXECUTE stmt USING @_isclip,@_limit_a,@_limit_b;
WHEN _field = 3 THEN
EXECUTE stmt USING @_year,@_month,@_name,@_limit_a,@_limit_b;
WHEN _field = 4 THEN
EXECUTE stmt USING @_year,@_name,@_limit_a,@_limit_b;
WHEN _field = 5 THEN
EXECUTE stmt USING @_state,@_name,@_limit_a,@_limit_b;
WHEN _field = 6 THEN
EXECUTE stmt USING @_filter,@_name,@_limit_a,@_limit_b;
WHEN _field = 7 THEN
EXECUTE stmt USING @_filter,@_name,@_limit_a,@_limit_b;
WHEN _field = 8 THEN
EXECUTE stmt USING @_limit_size_a,@_limit_size_b,@_name,@_limit_a,@_limit_b;
WHEN _field = 9 THEN
EXECUTE stmt USING @_cfilter,@_limit_a,@_limit_b;
WHEN _field = 10 THEN
EXECUTE stmt USING @_cfilter,@_limit_a,@_limit_b;
ELSE 
EXECUTE stmt USING @_limit_a,@_limit_b;    
END CASE;

COMMIT;

END;

