create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_CONTENT_ON_TRANSFERS_COUNT(IN _id_transfer int, IN _field int(10),
                                                                              IN _query varchar(192),
                                                                              IN _filter varchar(192),
                                                                              IN _limit_size_a bigint,
                                                                              IN _limit_size_b bigint)
BEGIN

DECLARE sqlcommand text;
DECLARE sqlcommand_v text;
DECLARE sqlcommand_c text;
DECLARE sqlcommand_v_fst text;
DECLARE sqlcommand_c_snd text;
DECLARE t1_a text;
DECLARE t1_b text;

DECLARE _total_clip int;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

DROP TEMPORARY TABLE IF EXISTS trf2;
SET t1_a = "CREATE TEMPORARY TABLE IF NOT EXISTS trf2 ";
SET t1_b = "insert into trf2 ";

SET @_id_transfer = _id_transfer;
SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_limit_size_a = _limit_size_a;
SET @_limit_size_b = _limit_size_b;
SET @_state = _query;
SET @_isclip = _query;

SET @_year = year(_filter);
SET @_month = month(_filter);



SET sqlcommand_v = "SELECT av.id_video,id_directory,0 as is_clip,av.name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,width,height,ratio,state,av.register_date,
							 FN_GET_ARCHIVE_VIDEO_HAS_PREVIEW(av.id_video) has_preview,FN_GET_ARCHIVE_VIDEO_THUMBNAIL(av.id_video) as thumbnail,FN_GET_ARCHIVE_VIDEO_TOTAL_CLIPS(av.id_video) as total_clips
				FROM archive_videos av, archive_transfers_videos_related tvr, archive_transfers at
 WHERE av.id_video = tvr.id_video AND at.id_transfer = tvr.id_transfer AND av.deleted = 0 AND tvr.id_transfer = ? ";

SET sqlcommand_v_fst = CONCAT(t1_a,sqlcommand_v);
SET @sqlcommand_v_fst = sqlcommand_v_fst;

PREPARE stmt_fst FROM @sqlcommand_v_fst;
EXECUTE stmt_fst USING @_id_transfer;

SET sqlcommand_c = "SELECT ac.id_clip,id_directory,1 as is_clip,ac.name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,width,height,ratio,state,ac.register_date,
							 FN_GET_ARCHIVE_CLIP_HAS_PREVIEW(ac.id_video) has_preview,FN_GET_ARCHIVE_CLIP_THUMBNAIL(ac.id_clip) as thumbnail,FN_GET_ARCHIVE_VIDEO_TOTAL_CLIPS(ac.id_video) as total_clips
				FROM archive_clips ac, archive_transfers_clips_related tvr, archive_transfers at
 WHERE ac.id_clip = tvr.id_clip AND at.id_transfer = tvr.id_transfer AND ac.deleted = 0 AND tvr.id_transfer = ? ";

SET sqlcommand_c_snd = CONCAT(t1_b,sqlcommand_c);
SET @sqlcommand_c_snd = sqlcommand_c_snd;

PREPARE stmt_snd FROM @sqlcommand_c_snd;
EXECUTE stmt_snd USING @_id_transfer;

SET sqlcommand = "SELECT count(1) as total FROM trf2 WHERE 1=1 ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like ? ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND is_clip = ? ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = ? AND month(register_date) = ?) AND (name like ? ) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = ?) AND (name like ? ) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = ?) AND (name like ?) ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (mime_type like ?) AND (name like ?) ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (CONCAT(width,'x',height) like ?) AND (name like ?) ");
WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (size BETWEEN ? AND ?) AND (name like ?) ");
WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND is_clip = 0 AND id_video = ? ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND is_clip = 1 AND id_video = ? ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
END CASE;

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _field = 1 THEN
EXECUTE stmt USING @_name;
WHEN _field = 2 THEN
EXECUTE stmt USING @_isclip;
WHEN _field = 3 THEN
EXECUTE stmt USING @_year,@_month,@_name;
WHEN _field = 4 THEN
EXECUTE stmt USING @_year,@_name;
WHEN _field = 5 THEN
EXECUTE stmt USING @_state,@_name;
WHEN _field = 6 THEN
EXECUTE stmt USING @_filter,@_name;
WHEN _field = 7 THEN
EXECUTE stmt USING @_filter,@_name;
WHEN _field = 8 THEN
EXECUTE stmt USING @_limit_size_a,@_limit_size_b,@_name;
WHEN _field = 9 THEN
EXECUTE stmt USING @_cfilter;
WHEN _field = 10 THEN
EXECUTE stmt USING @_cfilter;
ELSE 
EXECUTE stmt;    
END CASE;

COMMIT;

END;

