create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_VIDEOS_SYSTEM_TAGS(IN _room varchar(5), IN _id_user int(10),
                                                                      IN _id_directory int, IN _field int(10),
                                                                      IN _field_snd int(10), IN _field_trd int(10),
                                                                      IN _query varchar(192), IN _filter varchar(192),
                                                                      IN _filter_snd varchar(192),
                                                                      IN _filter_trd varchar(192),
                                                                      IN _limit_sys_a bigint, IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;
DECLARE sqlcommand_state text;
DECLARE sqlcommand_mime_type text;
DECLARE sqlcommand_height text;
DECLARE sqlcommand_bitrate text;
DECLARE sqlcommand_size text;
DECLARE sqlcommand_seconds text;
DECLARE sqlcommand_ratio text;

DECLARE sqlcommand_1_1 text;
DECLARE sqlcommand_dir text;
DECLARE sqlcommand_100 text;
DECLARE sqlcommand_101 text;
DECLARE sqlcommand_102 text;
DECLARE sqlcommand_103 text;
DECLARE sqlcommand_104 text;
DECLARE sqlcommand_105 text;
DECLARE sqlcommand_1000 text;
DECLARE sqlcommand_query text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################


START TRANSACTION;

SET @room = _room;
SET @id_user = _id_user;

SET @_id_video = _filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_tags_group = CONCAT("%",_filter_trd,"%");

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_id_directory = _id_directory;
SET @_room = _filter_snd;

SET sqlcommand_1_1 = " AND 1=1 ";
SET sqlcommand_dir = " AND av.id_directory = @_id_directory ";
SET sqlcommand_100 = " AND (av.id_video = @_id_video ) ";
SET sqlcommand_101 = " AND (av.id_video in (SELECT distinct id_video FROM archive_clips) ) ";
SET sqlcommand_102 = " AND (av.id_video in (SELECT distinct id_video FROM archive_transfers_videos_related) ) ";
SET sqlcommand_103 = " AND (av.id_video in (SELECT distinct id_video FROM archive_videos_segment_tags_related) ) ";
SET sqlcommand_104 = " AND (av.id_video in (SELECT distinct id_video FROM archive_rooms_related) ) ";
SET sqlcommand_105 = " AND (av.id_video in (SELECT distinct id_video FROM archive_rooms_related AND room = @_room) ) ";
SET sqlcommand_1000 = " AND (SELECT FN_MATCH_ARCHIVE_VIDEOS_TAGS_GROUPED(av.id_video) like @_tags_group ) ";
SET sqlcommand_query = " AND av.name like @_name ";

-- ##################################################################################################################################################################

/*
SET sqlcommand_state = "SELECT 7 as type,state as rvalue, count(1) as total FROM archive_videos av WHERE deleted = 0 "; 
	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_state =  CONCAT(sqlcommand_state, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_state =  CONCAT(sqlcommand_state, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_state =  CONCAT(sqlcommand_state, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_state =  CONCAT(sqlcommand_state, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_state =  CONCAT(sqlcommand_state, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_state =  CONCAT(sqlcommand_state, " ",sqlcommand_105);
		ELSE SET sqlcommand_state = CONCAT(sqlcommand_state, " ",sqlcommand_1_1);
		END CASE;
	END IF;
*/
-- ##################################################################################################################################################################
		
-- ##################################################################################################################################################################

SET sqlcommand_mime_type = "SELECT 2 as type,mime_type as rvalue, (SELECT count(1) FROM archive_videos av WHERE av.deleted = 0 AND av.mime_type = av2.mime_type "; 
	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_105);			
		ELSE SET sqlcommand_mime_type = CONCAT(sqlcommand_mime_type, " ",sqlcommand_1_1);
		END CASE;
	END IF;
-- ##################################################################################################################################################################

-- ##################################################################################################################################################################
SET sqlcommand_height = "SELECT 6,height as resolution, (SELECT count(1) FROM archive_videos av WHERE av.deleted = 0 AND av.height = av2.height ";
	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_105);			
		ELSE SET sqlcommand_height = CONCAT(sqlcommand_height, " ",sqlcommand_1_1);
		END CASE;
	END IF;
-- ##################################################################################################################################################################

-- ##################################################################################################################################################################
SET sqlcommand_bitrate = "SELECT 3,?,count(1) as total FROM archive_videos av WHERE deleted = 0 AND bitrate BETWEEN ? AND ? ";	
IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_bitrate =  CONCAT(sqlcommand_bitrate, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_bitrate =  CONCAT(sqlcommand_bitrate, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_bitrate =  CONCAT(sqlcommand_bitrate, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_bitrate =  CONCAT(sqlcommand_bitrate, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_bitrate =  CONCAT(sqlcommand_bitrate, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_bitrate =  CONCAT(sqlcommand_bitrate, " ",sqlcommand_105);			
		ELSE SET sqlcommand_bitrate = CONCAT(sqlcommand_bitrate, " ",sqlcommand_1_1);
		END CASE;
	END IF;
-- ##################################################################################################################################################################

-- ##################################################################################################################################################################
SET sqlcommand_size = "SELECT 4,?,count(1) as total FROM archive_videos av WHERE deleted = 0 AND size BETWEEN ? AND ? ";	
IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_105);			
		ELSE SET sqlcommand_size = CONCAT(sqlcommand_size, " ",sqlcommand_1_1);
		END CASE;
	END IF;
-- ##################################################################################################################################################################

-- ##################################################################################################################################################################
SET sqlcommand_seconds = "SELECT 1,?,count(1) as total FROM archive_videos av WHERE deleted = 0 AND seconds BETWEEN ? AND ? ";	
IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_seconds =  CONCAT(sqlcommand_seconds, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_seconds =  CONCAT(sqlcommand_seconds, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_seconds =  CONCAT(sqlcommand_seconds, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_seconds =  CONCAT(sqlcommand_seconds, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_seconds =  CONCAT(sqlcommand_seconds, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_seconds =  CONCAT(sqlcommand_seconds, " ",sqlcommand_105);			
		ELSE SET sqlcommand_seconds = CONCAT(sqlcommand_seconds, " ",sqlcommand_1_1);
		END CASE;
	END IF;
-- ##################################################################################################################################################################

-- ##################################################################################################################################################################
SET sqlcommand_ratio = "SELECT 5,ratio, (SELECT count(1) FROM archive_videos av WHERE av.deleted = 0 AND av.ratio = av2.ratio ";	
IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_ratio =  CONCAT(sqlcommand_ratio, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_ratio =  CONCAT(sqlcommand_ratio, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_ratio =  CONCAT(sqlcommand_ratio, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_ratio =  CONCAT(sqlcommand_ratio, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_ratio =  CONCAT(sqlcommand_ratio, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_ratio =  CONCAT(sqlcommand_ratio, " ",sqlcommand_105);			
		ELSE SET sqlcommand_ratio = CONCAT(sqlcommand_ratio, " ",sqlcommand_1_1);
		END CASE;
	END IF;

-- ##################################################################################################################################################################

-- ##################################################################################################################################################################

	IF(_id_directory > 0)
	THEN
	--   SET sqlcommand_state = CONCAT(sqlcommand_state,"",sqlcommand_dir);
	   SET sqlcommand_mime_type = CONCAT(sqlcommand_mime_type,"",sqlcommand_dir);
	   SET sqlcommand_height = CONCAT(sqlcommand_height,"",sqlcommand_dir);
	   SET sqlcommand_bitrate = CONCAT(sqlcommand_bitrate,"",sqlcommand_dir);
	   SET sqlcommand_size = CONCAT(sqlcommand_size,"",sqlcommand_dir);
	   SET sqlcommand_seconds = CONCAT(sqlcommand_seconds,"",sqlcommand_dir);
	   SET sqlcommand_ratio = CONCAT(sqlcommand_ratio,"",sqlcommand_dir);
	END IF;

	IF (_field_trd = 1000)
	THEN
	--   SET sqlcommand_state = CONCAT(sqlcommand_state,"",sqlcommand_1000);
	   SET sqlcommand_mime_type = CONCAT(sqlcommand_mime_type,"",sqlcommand_1000);
	   SET sqlcommand_height = CONCAT(sqlcommand_height,"",sqlcommand_1000);
	   SET sqlcommand_bitrate = CONCAT(sqlcommand_bitrate,"",sqlcommand_1000);
	   SET sqlcommand_size = CONCAT(sqlcommand_size,"",sqlcommand_1000);
	   SET sqlcommand_seconds = CONCAT(sqlcommand_seconds,"",sqlcommand_1000);
	   SET sqlcommand_ratio = CONCAT(sqlcommand_ratio,"",sqlcommand_1000);
	END IF;

	IF (_query <> '')
	THEN
	--   SET sqlcommand_state = CONCAT(sqlcommand_state,"",sqlcommand_query);
	   SET sqlcommand_mime_type = CONCAT(sqlcommand_mime_type,"",sqlcommand_query);
	   SET sqlcommand_height = CONCAT(sqlcommand_height,"",sqlcommand_query);
	   SET sqlcommand_bitrate = CONCAT(sqlcommand_bitrate,"",sqlcommand_query);
	   SET sqlcommand_size = CONCAT(sqlcommand_size,"",sqlcommand_query);
	   SET sqlcommand_seconds = CONCAT(sqlcommand_seconds,"",sqlcommand_query);
	   SET sqlcommand_ratio = CONCAT(sqlcommand_ratio,"",sqlcommand_query);
	END IF;


SET sqlcommand = "SELECT type,rvalue as value, total FROM (";
-- SET sqlcommand =  CONCAT(sqlcommand,sqlcommand_state, " GROUP BY state  ");
SET sqlcommand =  CONCAT(sqlcommand,sqlcommand_mime_type, " ) as total FROM archive_videos av2 WHERE av2.deleted = 0 GROUP BY mime_type  ");
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_height, " ) as total FROM archive_videos av2 WHERE av2.deleted = 0 GROUP BY height  ");
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_ratio, " ) as total FROM archive_videos av2 WHERE av2.deleted = 0 GROUP BY ratio  ");

SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_bitrate); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_bitrate); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_bitrate); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_bitrate); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_bitrate); 

SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_seconds); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_seconds); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_seconds); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_seconds); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_seconds); 

SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 

SET sqlcommand =  CONCAT(sqlcommand, " ) as tt ORDER by type,rvalue ");
-- BITRATE
SET @l3_ix1 = 1; SET @l3_1a = 0; SET @l3_1b = 5*1000*1000;
SET @l3_ix2 = 2; SET @l3_2a = 5*1000*1000; SET @l3_2b = 10*1000*1000;
SET @l3_ix3 = 3; SET @l3_3a = 10*1000*1000; SET @l3_3b = 30*1000*1000;
SET @l3_ix4 = 4; SET @l3_4a = 30*1000*1000; SET @l3_4b = 50*1000*1000;
SET @l3_ix5 = 5; SET @l3_5a = 50*1000*1000; SET @l3_5b = 99999999*1000*1000;

-- SECONDS
SET @l1_ix1 = 1; SET @l1_1a = 0; SET @l1_1b = 5*60;
SET @l1_ix2 = 2; SET @l1_2a = 5*60; SET @l1_2b = 10*60;
SET @l1_ix3 = 3; SET @l1_3a = 10*60; SET @l1_3b = 20*60;
SET @l1_ix4 = 4; SET @l1_4a = 20*60; SET @l1_4b = 30*60;
SET @l1_ix5 = 5; SET @l1_5a = 30*60; SET @l1_5b = 99999999*60;

-- SIZE
SET @l4_ix1 = 1; SET @l4_1a = 0; SET @l4_1b = 50*1024*1024;
SET @l4_ix2 = 2; SET @l4_2a = 50*1024*1024; SET @l4_2b = 100*1024*1024;
SET @l4_ix3 = 3; SET @l4_3a = 100*1024*1024; SET @l4_3b = 300*1024*1024;
SET @l4_ix4 = 4; SET @l4_4a = 300*1024*1024; SET @l4_4b = 500*1024*1024;
SET @l4_ix5 = 5; SET @l4_5a = 500*1024*1024; SET @l4_5b = 1024*1024*1024;
SET @l4_ix6 = 6; SET @l4_6a = 1024*1024*1024; SET @l4_6b = 99999999*1024*1024;


 -- select sqlcommand;

	 SET @sqlcommand = sqlcommand;
	 PREPARE stmt FROM @sqlcommand;
	 EXECUTE stmt  USING 
	 @l3_ix1,@l3_1a,@l3_1b,
	 @l3_ix2,@l3_2a,@l3_2b,
	 @l3_ix3,@l3_3a,@l3_3b,
	 @l3_ix4,@l3_4a,@l3_4b,
	 @l3_ix5,@l3_5a,@l3_5b,
	
	 @l1_ix1,@l1_1a,@l1_1b,
	 @l1_ix2,@l1_2a,@l1_2b,
	 @l1_ix3,@l1_3a,@l1_3b,
	 @l1_ix4,@l1_4a,@l1_4b,
	 @l1_ix5,@l1_5a,@l1_5b,

	 @l4_ix1,@l4_1a,@l4_1b,
	 @l4_ix2,@l4_2a,@l4_2b,
	 @l4_ix3,@l4_3a,@l4_3b,
	 @l4_ix4,@l4_4a,@l4_4b,
	 @l4_ix5,@l4_5a,@l4_5b,
	 @l4_ix6,@l4_6a,@l4_6b;
    
COMMIT;

END;

