create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_ALBUMS_ON_GALLERIES(IN _id_gallery int, IN _query varchar(192),
                                                                      IN _order tinyint, IN _order_by tinyint,
                                                                      IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_gallery = _id_gallery;

SET @_query = _query;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT agr.id_gallery, agr.id_album, a.id_directory, a.name, a.description,a.random, a.link,
FN_GET_ASSETS_NUM_IMAGENS_ON_ALBUMS(a.id_album) as total_images, FN_GET_ASSETS_LAST_IMAGE_ON_ALBUM(a.id_album) as cover_image, agr.register_date,agr.position
	FROM albums_galleries_related agr, albums a WHERE FN_GET_ASSETS_ALBUM_DIRECTORY_IS_DELETED(a.id_directory) = 0 AND a.id_album = agr.id_album AND agr.id_gallery = ? ";

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM albums_galleries_related WHERE id_gallery = _id_gallery;
	SET @_limit_b = _limit_b;
END IF;

IF(_query <> '')
THEN
   SET @_query = CONCAT("%",_query,"%");
   SET sqlcommand = CONCAT(sqlcommand," AND (a.name like ? OR a.description like ? ) ");
END IF;

CASE
WHEN _order_by = 1 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, "ORDER BY a.name ASC");
WHEN _order_by = 1 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, "ORDER BY a.name DESC");
WHEN _order_by = 2 AND _order = 2 THEN SET sqlcommand = CONCAT(sqlcommand, "ORDER BY a.register_date DESC");
ELSE SET sqlcommand = CONCAT(sqlcommand, "ORDER BY a.name ASC");
END CASE;

 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _query <> '' THEN
EXECUTE stmt USING @_id_gallery,@_query,@_query,@_limit_a,@_limit_b;
ELSE 
EXECUTE stmt USING @_id_gallery,@_limit_a,@_limit_b;    
END CASE;

COMMIT;

END;

