create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_ON_ALBUMS_COUNT(IN _id_album int, IN _field int(10),
                                                                  IN _query varchar(192), IN _filter varchar(192),
                                                                  IN _limit_size_a bigint, IN _limit_size_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;


SET @_id_album = _id_album;
SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_limit_size_a = _limit_size_a;
SET @_limit_size_b = _limit_size_b;
SET @_state = _query;

SET @_year = year(_filter);
SET @_month = month(_filter);

SET sqlcommand = " SELECT count(1) as total
				FROM assets a, assets_albums_related aar
 WHERE a.id_asset = aar.id_asset AND a.deleted = 0 AND aar.id_album = ? ";

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like ? OR description like ? OR ((SELECT count(1) FROM assets_tags at, assets_tags_related atr WHERE at.id_tag = atr.id_tag AND atr.id_asset = a.id_asset AND name_stripped like ?) > 0)) ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like ? ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like ? ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_ASSETS_TAGS_GROUPED(a.id_asset) like ?) AND (name like ? OR description like ?) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(a.register_date) = ? AND month(a.register_date) = ?) AND (name like ? OR description like ?) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(a.register_date) = ?) AND (name like ? OR description like ?) ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = ?) AND (name like ? OR description like ?) ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (mime_type like ?) AND (name like ? OR description like ?) ");
WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (CONCAT(width,'x',height) like ?) AND (name like ? OR description like ?) ");
WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (size BETWEEN ? AND ?) AND (name like ? OR description like ?) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
END CASE;

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

CASE
WHEN _field = 0 THEN
EXECUTE stmt USING @_id_album,@_name,@_description,@_tags_stripped;
WHEN _field = 1 THEN
EXECUTE stmt USING @_id_album,@_name;
WHEN _field = 2 THEN
EXECUTE stmt USING @_id_album,@_description;
WHEN _field = 3 THEN
EXECUTE stmt USING @_id_album,@_filter,@_name,@_description;
WHEN _field = 4 THEN
EXECUTE stmt USING @_id_album,@_year,@_month,@_name,@_description;
WHEN _field = 5 THEN
EXECUTE stmt USING @_id_album,@_year,@_name,@_description;
WHEN _field = 6 THEN
EXECUTE stmt USING @_id_album,@_filter,@_name,@_description;
WHEN _field = 7 THEN
EXECUTE stmt USING @_id_album,@_filter,@_name,@_description;
WHEN _field = 8 THEN
EXECUTE stmt USING @_id_album,@_filter,@_name,@_description;
WHEN _field = 9 THEN
EXECUTE stmt USING @_id_album,@_limit_size_a,@_limit_size_b,@_name,@_description;
ELSE 
EXECUTE stmt USING @_id_album;    
END CASE;

COMMIT;

END;

