create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_ROOM(IN _room varchar(5), IN _id_user int(10),
                                                       IN _id_directory int(10), IN _field int(10),
                                                       IN _field_snd int(10), IN _field_trd int(10),
                                                       IN _query varchar(192), IN _filter varchar(192),
                                                       IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                       IN _limit_size_a bigint, IN _limit_size_b bigint,
                                                       IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM assets WHERE deleted = 0 AND FN_GET_ASSETS_ASSET_IN_ROOM(id_asset,_id_user,_room) = 1;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;

SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_tags_group = CONCAT("%",_filter_trd,"%");
SET @_id_asset = _filter_snd;
SET @_id_album = _filter_snd;
SET @_room = _filter_snd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;
SET @_limit_size_a = _limit_size_a;
SET @_limit_size_b = _limit_size_b;
SET @_id_directory = _id_directory;

SET @_year = year(_filter);
SET @_month = month(_filter);

IF(_id_directory = -1)
THEN
	SET sqlcommand = "SELECT id_asset, id_directory,id_storage,id_cdn, name, description, image_title,image_alter_text,link, filename,extension,mime_type,size,width,height,state,register_date FROM assets a WHERE id_directory is null AND deleted = 0 ";
	
	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ASSETS_ASSET_IN_ROOM(id_asset,@id_user,@room) = 1 ");
	END IF;
	
	SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC LIMIT ?,?");

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b;
ELSE
	IF (_id_directory = 0) OR (SELECT count(1) FROM assets_directories WHERE id_directory = _id_directory)
	THEN

	SET sqlcommand = "SELECT id_asset, id_directory,id_storage,id_cdn, name, description, image_title,image_alter_text,link, filename,extension,mime_type,size,width,height,state,register_date FROM assets a WHERE deleted = 0 ";

	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ASSETS_ASSET_IN_ROOM(id_asset,@id_user,@room) = 1 ");
	END IF;

	IF (_id_directory > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND id_directory = @_id_directory ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset = @_id_asset ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_albums_related) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_transfers_related) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_rooms_related) ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_rooms_related AND room = @_room) ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_albums_related WHERE id_album = @_id_album) ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_field_trd = 1000)
	THEN
		SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_ASSETS_TAGS_GROUPED(a.id_asset) like @_tags_group ) ");
	END IF;

	CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like @_name OR description like @_description OR ((SELECT count(1) FROM assets_tags at, assets_tags_related atr WHERE at.id_tag = atr.id_tag AND atr.id_asset = a.id_asset AND name_stripped like @_tags_stripped) > 0)) ");
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
	WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
	WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_ASSETS_TAGS_GROUPED(a.id_asset) like @_filter) AND (name like @_name OR description like @_description) ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND (name like @_name OR description like @_description) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) AND (name like @_name OR description like @_description) ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_cfilter) AND (name like @_name OR description like @_description) ");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (mime_type like @_filter) AND (name like @_name OR description like @_description) ");
	WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (CONCAT(width,'x',height) like @_filter) AND (name like @_name OR description like @_description) ");
	WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (size BETWEEN @_limit_size_a AND @_limit_size_b) AND (name like @_name OR description like @_description) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

	SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC LIMIT ?,?");
	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 

	ELSE
	    SELECT -2 as return_code;
	END IF;
END IF;	

COMMIT;

END;

