create
    definer = skoiypp@`%` procedure SP_GET_LIVE_COMPOSES_TO_VIDEO_RELATED()
BEGIN

DECLARE _idPlaylist INT;
DECLARE _idComposed INT;
DECLARE _idLive INT;

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_name varchar(255);
DECLARE c_seconds INT;
DECLARE c_id_video INT;
DECLARE c_video_date datetime;
DECLARE c_stream varchar(255);

DECLARE cursor_loader CURSOR FOR SELECT id_video,name,seconds,CONVERT(SUBSTRING_INDEX(name,'|',1),datetime),REPLACE(SUBSTRING_INDEX(SUBSTRING_INDEX(name,'|',-1),'_',1),'.mp4','') FROM videos WHERE deleted = 0 AND id_video not in (SELECT id_video FROM video_composed WHERE id_video > 0) AND CONVERT(SUBSTRING_INDEX(name,'|',1),datetime) is not null;

DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;


DECLARE exit handler for sqlexception
  BEGIN
    
	 SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

DROP TEMPORARY TABLE IF EXISTS biz_tmp_composes;
CREATE TEMPORARY TABLE IF NOT EXISTS biz_tmp_composes SELECT 0 as id_live, 0 as id_composed, 0 as id_video,0 as id_playlist,now() as video_date,0 as seconds;

 
   
    OPEN cursor_loader;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_loader INTO c_id_video,c_name,c_seconds,c_video_date,c_stream;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	

        SET c_video_date = DATE_ADD(c_video_date,INTERVAL +time_to_sec(TIMEDIFF(NOW(), UTC_TIMESTAMP)) SECOND);
        
		SET _idLive = (SELECT id_live FROM Accounts.accounts_live_server_settings WHERE stream = c_stream );

		SET _idComposed = (SELECT id_composed FROM video_composed WHERE id_live = _idLive AND publish_date BETWEEN DATE_ADD(c_video_date,INTERVAL -5 MINUTE) AND DATE_ADD(c_video_date,INTERVAL 5 MINUTE) LIMIT 0,1) ;
		SET _idPlaylist = (SELECT id_playlist FROM video_composed_playlists_related WHERE id_composed = _idComposed LIMIT 0,1);
        
			IF(_idComposed is not null)
			THEN
				INSERT into biz_tmp_composes SELECT _idLive,_idComposed,c_id_video,_idPlaylist,c_video_date,c_seconds;
			END IF;
        
	

      END LOOP read_loop;

    CLOSE cursor_loader;
 
 
	SELECT id_live, id_composed, id_video,id_playlist,video_date,seconds FROM biz_tmp_composes WHERE id_composed > 0;
   
 COMMIT;

END;

