create
    definer = skoiypp@`%` procedure SP_GET_POSTS(IN _field int(10), IN _query varchar(192), IN _filter varchar(192),
                                                 IN _iso_lang varchar(10), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1 OR _limit_b = 0)
THEN
	IF(_iso_lang = '')
	THEN
		SELECT count(1) into _limit_b FROM posts_l10n;
	ELSE
		SELECT count(1) into _limit_b FROM posts_l10n WHERE iso_language = _iso_lang;
	END IF;
END IF;

SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_iso_lang = _iso_lang;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET @_year = year(_filter);
SET @_month = month(_filter);

IF(_iso_lang = '')
THEN
	SET sqlcommand = "SELECT id_l10n,id_post,iso_language, title, description,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark, publish_date,begin_date,end_date, register_date, state, FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) as tags FROM posts_l10n pln WHERE 1=1 ";
ELSE
	SET sqlcommand = "SELECT id_l10n,id_post,iso_language, title, description,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark, publish_date,begin_date,end_date, register_date, state, FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) as tags FROM posts_l10n pln WHERE iso_language = ? ";
END IF;


CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like ? OR description like ? OR ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like ?) > 0)) GROUP BY id_post ORDER BY register_date DESC LIMIT ?,?");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like ? GROUP BY id_post ORDER BY register_date DESC LIMIT ?,?");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like ? GROUP BY id_post ORDER BY register_date DESC LIMIT ?,?");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) like ?) AND (title like ? OR description like ?) ORDER BY register_date DESC LIMIT ?,?");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = ? AND month(register_date) = ?) AND (title like ? OR description like ?) GROUP BY id_post ORDER BY register_date DESC LIMIT ?,?");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = ?) AND (title like ? OR description like ?) GROUP BY id_post ORDER BY register_date DESC LIMIT ?,?");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = ?) AND (title like ? OR description like ?) GROUP BY id_post ORDER BY register_date DESC LIMIT ?,?");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_l10n in (SELECT id_l10n FROM posts_l10n_authors WHERE id_author = ?) AND (title like ? OR description like ?) ORDER BY register_date DESC LIMIT ?,?");
ELSE SET sqlcommand = CONCAT(sqlcommand, " GROUP BY id_post ORDER BY register_date DESC LIMIT ?,?");
END CASE;

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

IF(_iso_lang = '')
THEN
	CASE
	WHEN _field = 0 THEN
	EXECUTE stmt USING @_title,@_description,@_tags_stripped,@_limit_a,@_limit_b;
	WHEN _field = 1 THEN
	EXECUTE stmt USING @_title,@_limit_a,@_limit_b;
	WHEN _field = 2 THEN
	EXECUTE stmt USING @_description,@_limit_a,@_limit_b;
	WHEN _field = 3 THEN
	EXECUTE stmt USING @_filter,@_title,@_description,@_limit_a,@_limit_b;
	WHEN _field = 4 THEN
	EXECUTE stmt USING @_year,@_month,@_title,@_description,@_limit_a,@_limit_b;
	WHEN _field = 5 THEN
	EXECUTE stmt USING @_year,@_title,@_description,@_limit_a,@_limit_b;
	WHEN _field = 6 THEN
	EXECUTE stmt USING @_cfilter,@_title,@_description,@_limit_a,@_limit_b;
	WHEN _field = 7 THEN
	EXECUTE stmt USING @_cfilter,@_title,@_description,@_limit_a,@_limit_b;
	ELSE 
	EXECUTE stmt USING @_limit_a,@_limit_b;    
	END CASE;    
ELSE
	CASE
	WHEN _field = 0 THEN
	EXECUTE stmt USING @_iso_lang,@_title,@_description,@_tags_stripped,@_limit_a,@_limit_b;
	WHEN _field = 1 THEN
	EXECUTE stmt USING @_iso_lang,@_title,@_limit_a,@_limit_b;
	WHEN _field = 2 THEN
	EXECUTE stmt USING @_iso_lang,@_description,@_limit_a,@_limit_b;
	WHEN _field = 3 THEN
	EXECUTE stmt USING @_iso_lang,@_filter,@_title,@_description,@_limit_a,@_limit_b;
	WHEN _field = 4 THEN
	EXECUTE stmt USING @_iso_lang,@_year,@_month,@_title,@_description,@_limit_a,@_limit_b;
	WHEN _field = 5 THEN
	EXECUTE stmt USING @_iso_lang,@_year,@_title,@_description,@_limit_a,@_limit_b;
	WHEN _field = 6 THEN
	EXECUTE stmt USING @_iso_lang,@_cfilter,@_title,@_description,@_limit_a,@_limit_b;
	WHEN _field = 7 THEN
	EXECUTE stmt USING @_iso_lang,@_cfilter,@_title,@_description,@_limit_a,@_limit_b;
	ELSE 
	EXECUTE stmt USING @_iso_lang,@_limit_a,@_limit_b;    
	END CASE;  
END IF;
        
COMMIT;

END;

