create
    definer = skoiypp@`%` procedure SP_GET_POSTS_COUNT(IN _field int(10), IN _query varchar(192),
                                                       IN _filter varchar(192), IN _iso_lang varchar(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_iso_lang = _iso_lang;

SET @_year = year(_filter);
SET @_month = month(_filter);

IF(_iso_lang = '')
THEN
	SET sqlcommand = "SELECT count(1) as total FROM posts_l10n pln WHERE 1=1 ";
ELSE
	SET sqlcommand = "SELECT count(1) as total FROM posts_l10n pln WHERE iso_language = ? ";
END IF;


CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like ? OR description like ? OR ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like ?) > 0))");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like ? ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like ? ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) like ?) AND (title like ? OR description like ?)");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = ? AND month(register_date) = ?) AND (title like ? OR description like ?)");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = ?) AND (title like ? OR description like ?)");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = ?) AND (title like ? OR description like ?)");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

IF(_iso_lang = '')
THEN
	CASE
	WHEN _field = 0 THEN
	EXECUTE stmt USING @_title,@_description,@_tags_stripped;
	WHEN _field = 1 THEN
	EXECUTE stmt USING @_title;
	WHEN _field = 2 THEN
	EXECUTE stmt USING @_description;
	WHEN _field = 3 THEN
	EXECUTE stmt USING @_filter,@_title,@_description;
	WHEN _field = 4 THEN
	EXECUTE stmt USING @_year,@_month,@_title,@_description;
	WHEN _field = 5 THEN
	EXECUTE stmt USING @_year,@_title,@_description;
	WHEN _field = 6 THEN
	EXECUTE stmt USING @_filter,@_title,@_description;
	ELSE 
	EXECUTE stmt;    
	END CASE;    
ELSE
	CASE
	WHEN _field = 0 THEN
	EXECUTE stmt USING @_iso_lang,@_title,@_description,@_tags_stripped;
	WHEN _field = 1 THEN
	EXECUTE stmt USING @_iso_lang,@_title;
	WHEN _field = 2 THEN
	EXECUTE stmt USING @_iso_lang,@_description;
	WHEN _field = 3 THEN
	EXECUTE stmt USING @_iso_lang,@_filter,@_title,@_description;
	WHEN _field = 4 THEN
	EXECUTE stmt USING @_iso_lang,@_year,@_month,@_title,@_description;
	WHEN _field = 5 THEN
	EXECUTE stmt USING @_iso_lang,@_year,@_title,@_description;
	WHEN _field = 6 THEN
	EXECUTE stmt USING @_iso_lang,@_filter,@_title,@_description;
	ELSE 
	EXECUTE stmt USING @_iso_lang;    
	END CASE;  
END IF;
        
COMMIT;

END;

