create
    definer = skoiypp@`%` procedure SP_GET_VIDEO_PROFILES(IN _field int(10), IN _field_snd int(10),
                                                          IN _field_trd int(10), IN _query varchar(192),
                                                          IN _filter varchar(192), IN _filter_snd varchar(192),
                                                          IN _filter_trd varchar(192), IN _iso_lang varchar(10),
                                                          IN _limit_a int(10), IN _limit_b int(10), IN _order int(10),
                                                          IN _order_by int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1 OR _limit_b = 0)
THEN
	IF(_iso_lang = '')
	THEN
		SELECT count(1) into _limit_b FROM video_profiles_l10n;
	ELSE
		SELECT count(1) into _limit_b FROM video_profiles_l10n WHERE iso_language = _iso_lang;
	END IF;
END IF;

SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");

SET @_tags_group = REPLACE(_filter_trd,'%','');

SET @id_profile = _filter_snd;
SET @id_composed = _filter_snd;
SET @id_playlist = _filter_snd;
SET @state = _filter_snd;

SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");

SET @_iso_lang = _iso_lang;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET @_year = year(_filter);
SET @_month = month(_filter);

	IF(_iso_lang = '')
	THEN
		SET sqlcommand = "SELECT id_profile,id_l10n,iso_language,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,state,update_date,register_date, FN_GET_VIDEO_PROFILE_L10N_TAGS_GROUPED(vp.id_l10n) as tags FROM video_profiles_l10n vp WHERE 1=1 ";
	ELSE
		SET sqlcommand = "SELECT id_profile,id_l10n,iso_language,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,state,update_date,register_date, FN_GET_VIDEO_PROFILE_L10N_TAGS_GROUPED(vp.id_l10n) as tags FROM video_profiles_l10n vp WHERE iso_language = @_iso_lang";
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_profile = @id_profile ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_profile in (SELECT id_profile FROM video_composed WHERE id_composed = @id_composed) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_profile in (SELECT id_profile FROM video_composed WHERE id_composed in (SELECT id_composed FROM video_composed_playlists_related WHERE id_playlist = @id_playlist)) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @state ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_profile in (SELECT id_profile FROM video_composed) ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_profile in (SELECT id_profile FROM video_composed WHERE id_composed in (SELECT id_composed FROM video_composed_playlists_related)) ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_field_trd = 1000)
	THEN
		
		SET sqlcommand =  CONCAT(sqlcommand, " AND id_profile in ( SELECT id_profile FROM video_profiles_l10n WHERE id_l10n in (SELECT id_l10n FROM video_profiles_l10n_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) )) ");  
	END IF;

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like @_title OR description like @_description OR ((SELECT count(1) FROM video_tags vt, video_profiles_l10n_tags_related vptr WHERE vt.id_tag = vptr.id_tag AND vptr.id_l10n = vp.id_l10n AND name_stripped like @_tags_stripped) > 0)) ");
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_VIDEO_PROFILE_L10N_TAGS_GROUPED(vp.id_l10n) like @_filter) AND (title like @_title OR description like @_description) ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND (title like @_title OR description like @_description) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) AND (title like @_title OR description like @_description) ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_cfilter) AND (title like @_title OR description like @_description) ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " AND FN_GET_VIDEO_IS_LIVE_PROFILE(id_profile) = 0 ");
SET sqlcommand = CONCAT(sqlcommand, " GROUP BY id_profile ");

CASE

WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");

WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title DESC");
WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

EXECUTE stmt USING @_limit_a,@_limit_b;  
        
COMMIT;

END;

