create
    definer = skoiy@`%` procedure SP_SET_ADS_VIDEO_VERSIONS(IN _id_ad int, IN _file_name varchar(192),
                                                            IN _extension varchar(8), IN _width int(10),
                                                            IN _height int(10), IN _version varchar(192),
                                                            IN _version_type varchar(192), IN _size bigint,
                                                            IN _bitrate bigint, IN _audio_bitrate bigint,
                                                            IN _default_version int(10), IN _id_storage int(10),
                                                            IN _id_cdn int(10))
BEGIN

    DECLARE p_last_id INT UNSIGNED;
    DECLARE _is_default TINYINT(1);


    DECLARE exit handler for sqlexception
        BEGIN
            
            SELECT -1 as return_code;
            rollback;
        END;


    SET p_last_id = 0;
    SET _is_default = 0;

    START TRANSACTION;

    IF NOT EXISTS (SELECT id_ad FROM ads_video_versions WHERE id_ad = _id_ad AND version = _version AND version_type = _version_type)
    THEN

        IF(_version = _default_version)
        THEN
            SET _is_default = 1;
        END IF;

        INSERT into ads_video_versions(id_ad,id_storage,id_cdn,filename,extension,width,height,version,version_type,size,bitrate,audio_bitrate,is_default,register_date) VALUES(_id_ad,_id_storage,_id_cdn,_file_name,_extension,_width,_height,_version,_version_type,_size,_bitrate,_audio_bitrate,_is_default,now());
        SET p_last_id = last_insert_id();
        SELECT id_version,id_ad,id_storage,id_cdn,filename,extension,width,height,version,version_type,size,state,bitrate,audio_bitrate,is_default FROM ads_video_versions WHERE id_version = p_last_id;
    ELSE
        UPDATE ads_video_versions SET id_storage = _id_storage, id_cdn = _id_cdn, update_date = now() WHERE id_ad = _id_ad AND version = _version AND version_type = _version_type;
        SELECT -2 as return_code;
    END IF;

    COMMIT;

END;

